/////////////////////////////////////////////////////////////////////////
//		CFtCtrl
//		FT8UXXX API bpNX
//	l	OX[ꍇ́AFTCTRL_THROW_EXCEPTION `Ă
//	쐬	Y.Tomohara

#if !defined(AFX_FTCTRL_H__BEAC0ADD_DDB1_4CFD_AC2C_F7BE9A0635A3__INCLUDED_)
#define AFX_FTCTRL_H__BEAC0ADD_DDB1_4CFD_AC2C_F7BE9A0635A3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FTD2XX.H"


#define	MAX_ENUM_DEVICES	16		// 񋓂foCX̍ő吔
#define	MAX_DESC_LEN		64		// fBXNv^̍ő咷 ('\0'܂)
#define	MAX_SER_LEN			64		// VAԍ̍ő咷 ('\0'܂)


class CFtDevInfo
{
public:
	CFtDevInfo(int nIndex, const char* szDesc, const char* szSer)
	{
		m_nIndex	= nIndex;
		m_strDesc	= szDesc;
		m_strSer	= szSer;
	}

	int		m_nIndex;
	CString	m_strDesc;
	CString	m_strSer;
};

typedef CList<CFtDevInfo*, CFtDevInfo*>	CFtDevInfoList;


class CFtCtrl  
{
public:
	CFtCtrl();
	virtual ~CFtCtrl();

	FT_HANDLE GetFtHandle() const		{ return	m_hFt; }
	void RemoveAllDeviceList(CFtDevInfoList* pListInfo);
	FT_STATUS EnumDevices(CFtDevInfoList* pListInfo);

private:
	FT_STATUS ValidStatus(FT_STATUS nStatus, const char* szFunc, BOOL fThrowException = TRUE);

private:
	FT_HANDLE	m_hFt;					// foCX̃nh(:INVALID_HANDLE_VALUE)

public:
	FT_STATUS Open(
		int deviceNumber
		);

		FT_STATUS OpenEx(
		PVOID pArg1,
		DWORD Flags
		);

	FT_STATUS ListDevices(
		PVOID pArg1,
		PVOID pArg2,
		DWORD Flags
		);

	FT_STATUS Close();

	FT_STATUS Read(
		LPVOID lpBuffer,
		DWORD nBufferSize,
		LPDWORD lpBytesReturned
		);

	FT_STATUS Write(
	//	LPVOID lpBuffer,
		const VOID* lpBuffer,
		DWORD nBufferSize,
		LPDWORD lpBytesWritten
		);

	FT_STATUS IoCtl(
		DWORD dwIoControlCode,
		LPVOID lpInBuf,
		DWORD nInBufSize,
		LPVOID lpOutBuf,
		DWORD nOutBufSize,
		LPDWORD lpBytesReturned,
		LPOVERLAPPED lpOverlapped
		);

	FT_STATUS SetBaudRate(
		ULONG BaudRate
		);

	FT_STATUS SetDivisor(
		USHORT Divisor
		);

	FT_STATUS SetDataCharacteristics(
		UCHAR WordLength,
		UCHAR StopBits,
		UCHAR Parity
		);

	FT_STATUS SetFlowControl(
		USHORT FlowControl,
		UCHAR XonChar,
		UCHAR XoffChar
		);

	FT_STATUS ResetDevice();

	FT_STATUS SetDtr();

	FT_STATUS ClrDtr();

	FT_STATUS SetRts();

	FT_STATUS ClrRts();

	FT_STATUS GetModemStatus(
		ULONG *pModemStatus
		);

	FT_STATUS SetChars(
		UCHAR EventChar,
		UCHAR EventCharEnabled,
		UCHAR ErrorChar,
		UCHAR ErrorCharEnabled
		);

	FT_STATUS Purge(
		ULONG Mask
		);

	FT_STATUS SetTimeouts(
		ULONG ReadTimeout,
		ULONG WriteTimeout
		);

	FT_STATUS GetQueueStatus(
		DWORD *dwRxBytes
		);

	FT_STATUS SetEventNotification(
		DWORD Mask,
		PVOID Param
		);

	FT_STATUS GetStatus(
		DWORD *dwRxBytes,
		DWORD *dwTxBytes,
		DWORD *dwEventDWord
		);

	FT_STATUS SetBreakOn();

	FT_STATUS SetBreakOff();

	FT_STATUS SetWaitMask(
		DWORD Mask
		);

	FT_STATUS WaitOnMask(
		DWORD *Mask
		);

	FT_STATUS GetEventStatus(
		DWORD *dwEventDWord
		);

	FT_STATUS ReadEE(
		DWORD dwWordOffset,
		LPWORD lpwValue
		);

	FT_STATUS WriteEE(
		DWORD dwWordOffset,
		WORD wValue
		);

	FT_STATUS EraseEE();

	// FT8U232/245BM
	FT_STATUS EE_Program(
		PFT_PROGRAM_DATA pData
		);

	FT_STATUS EE_Read(
		PFT_PROGRAM_DATA pData
		);

	FT_STATUS EE_UASize(
		LPDWORD lpdwSize
		);

	FT_STATUS EE_UAWrite(
		PUCHAR pucData,
		DWORD dwDataLen
		);

	FT_STATUS EE_UARead(
		PUCHAR pucData,
		DWORD dwDataLen,
		LPDWORD lpdwBytesRead
		);

	FT_STATUS SetLatencyTimer(
		UCHAR ucLatency
		);

	FT_STATUS GetLatencyTimer(
		PUCHAR pucLatency
		);

	FT_STATUS SetBitMode(
		UCHAR ucMask,
		UCHAR ucEnable
		);

	FT_STATUS GetBitMode(
		PUCHAR pucMode
		);

	FT_STATUS SetUSBParameters(
		ULONG ulInTransferSize,
		ULONG ulOutTransferSize
		);

	FT_STATUS GetDeviceInfo(
		FT_DEVICE *lpftDevice,
		LPDWORD lpdwID,
		PCHAR SerialNumber,
		PCHAR Description,
		LPVOID Dummy
		);
};

#endif // !defined(AFX_FTCTRL_H__BEAC0ADD_DDB1_4CFD_AC2C_F7BE9A0635A3__INCLUDED_)
