// LcdCtrl.h: CLcdCtrl NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LCDCTRL_H__54E6ED70_1D97_44F0_9515_98F54EA4D48C__INCLUDED_)
#define AFX_LCDCTRL_H__54E6ED70_1D97_44F0_9515_98F54EA4D48C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	FTCTRL_THROW_EXCEPTION		// Ogp
#include "FtCtrl.h"

#define	LCD_RS	(1<<4)		// RS
#define	LCD_E1	(1<<5)		// Enable #1
#define	LCD_E2	(1<<6)		// Enable #2 (Reserved)
#define	LCD_PWR	(1<<7)		// Power 0:ON

#define	LCD_BITMODE_WRITE	(LCD_RS | LCD_E1 | LCD_E2 | LCD_PWR | 0x0f)
#define	LCD_BITMODE_GETKEY	(LCD_RS | LCD_E1 | LCD_E2 | LCD_PWR)
#define	LCD_KEYDATA_MASK	0x0f


typedef struct tagLCDCMD_INFO
{
	BOOL	fRS;
	BYTE	bCmd;
	BYTE	bMask;
	int		nWait;
}LCDCMD_INFO, *LPLCDCMD_INFO;

enum LCDCMD
{
	LCDCMD_CLEAR_DISPLAY,
	LCDCMD_CURSOR_AT_HOME,
	LCDCMD_ENTRY_MODE_SET,
	LCDCMD_DISPLAY_MODE_SET,
	LCDCMD_CURSOR_MODE_SET,
	LCDCMD_INITIAL_SET,
	LCDCMD_SET_CGRAM_ADDR,
	LCDCMD_SET_DDRAM_ADDR,
	LCDCMD_DATA_WRITE
};


class CLcdCtrl  
{
public:
	CLcdCtrl();
	virtual ~CLcdCtrl();

	BOOL Open(int nDevID = 0);
	void Close();

	BOOL WriteChar(char ch);
	BOOL WriteString(const char* szData);
	BOOL LocateCursor(int px, int py);
	BOOL ClearScreen();
	int GetKeyData();
	BOOL SetFont(int nIndex, const BYTE* pbData, int nLen);

private:
	BOOL WriteCommand(LCDCMD nCmd, BYTE bData);
	void WaitMSec(int nMSec);

	DWORD	m_dwLastExecutedTick;
	int		m_nWait;
	CFtCtrl	m_ft;
	BOOL	m_fOpen;
};

#endif // !defined(AFX_LCDCTRL_H__54E6ED70_1D97_44F0_9515_98F54EA4D48C__INCLUDED_)
